var isFunction = require('isfunction');
var map = require('lodash.map');
var groupBy = require('lodash.groupby');
var memoize = require('lodash.memoize');
var mgby = memoize(groupBy);
module.exports = function findChildren(root, items, opts, mapper) {
    if ( items === void 0 ) items = [];
    if ( opts === void 0 ) opts = {};

    var rootKey = opts.rootKey;
    var foreignKey = opts.foreignKey;
    var withRoot = opts.withRoot;
    var rootKeyOnly = opts.rootKeyOnly;
    var enableMemoize = opts.enableMemoize;
    var groupItemsByForeignKey = enableMemoize ? mgby(items, foreignKey) : groupBy(items, foreignKey);
    var children = [root];
    var _children = [].concat(children);
    recurse();
    if (!withRoot) 
        { children.shift(); }
    if (rootKeyOnly) 
        { children = map(children, rootKey); }
    if (isFunction(mapper)) 
        { return map(children, mapper); }
    return children;
    function recurse() {
        for (var i = 0, list = _children; i < list.length; i += 1) {
            child = list[i];

            _children.shift();
            var foundChildren = groupItemsByForeignKey[child[rootKey]];
            if (!foundChildren) 
                { return recurse(); }
            children.push.apply(children, foundChildren);
            _children.push.apply(_children, foundChildren);
            recurse();
        }
    }
    
};
//# sourceMappingURL=recura.m.js.map
